# fbp2/sino-weight.jl

export fbp_sino_weight

#using Sinograms: SinoFan, _geom_gamma


"""
    fbp_sino_weight(sg::SinoFan)
Return 1D sinogram weighting for first step of 2D fan-beam FBP.
"""
function fbp_sino_weight(sg::SinoFan)
    gam = _geom_gamma(sg)
    return @. abs(sg.dso * cos(gam) - sg.source_offset * sin(gam)) / sg.dsd
end
